/*	plt/axis.h		Paul Albrecht		Feb 1988

	Copyright (C) Paul Albrecht 1988.  All rights reserved.

	Last Update:	Nov 20, 1989
	EMACS_MODES:	tabstop=4
*/


typedef struct	{
	char	name;	/* 'x' or 'y'	*/
	double	min;	/* lower limit	*/
	double	max;	/* upper limit	*/
	double	cr;		/* where this axis crosses the other axis	*/
	double	aoff;	/* offset from other axis (alternative to cr)	*/
	double	mlt;	/* if != DEFAULT make axis and tics = 0 mod mlt	*/
	double	tic;	/* spacing between tic marks			*/
	double	tmark;	/* a tic which must be maked and labeled	*/
	double	tscl;	/* scale factor for tic mark length		*/
	long	skp;	/* label only every `skp'th tick mark		*/
	char	*pfm;	/* format (e.g. %4.2f) for outputing tic values	*/
	char	*lbl;	/* label for the axis	*/
	char	*base;	/* base for log plots	*/
	short	mode;	/* what to show		*/
	Boolean	logflg;	/* YES for log axis	*/
	Boolean	rev;	/* put reverse the axis tics and labels		*/
	double	scl;	/* scaling from user to device coordinates	*/
	double	off;	/* offset from user to device coordinates	*/
	double	acchi;	/* how much the xmax can be increased		*/
	double	acclo;	/* how much the xmin can be decreased		*/
	char	*numfg;	/* name of font group to use axis numbers	*/
	char	*lblfg;	/* name of font group to use for axis label	*/
	char	*extra;
	int		lo;		/* same as cr but in plot device coordinates	*/
	int		hi;		/* opposite end from lo				*/
	int		(*this)(); /* subr for this axis device coordinate	*/ 
	int		(*other)();/* subr for the other axis device coordinate	*/
	}	AxisInfo, *AxisPtr;

typedef	struct	{
	AxisPtr	a;
	double	tic;
	double	scl;
	char	*lbl;
	}	TicInfo, *TicPtr;



void	PROTO( AxisInit, (Mode) );
void	PROTO( TicInit, (Mode) );
int		PROTO( X, (double) );
int		PROTO( Y, (double) );



COMMON	AxisInfo	xa, ya;

COMMON	TicPtr	tics;

COMMON	double	xfract, yfract,
		xmin, xmax, ymin, ymax,
		xwmins, xwmaxs, ywmins, ywmaxs;


COMMON	Boolean	ticlogic;

COMMON	int		xwmin, xwmax, ywmin, ywmax;

COMMON	Uint	ntics, maxtics;

COMMON	char	*axisfile, *gridfg, *gridtype;


void	PROTO( AxisInit, (Mode) );
void	PROTO( TicInit, (Mode) );
void	PROTO( SetupAxes, () );
void	PROTO( TicDef, (AxisPtr,double,char *,double,Boolean) );

void	PROTO( XAxisDraw, () );
void	PROTO( YAxisDraw, () );
void	PROTO( LinearTicLogic, (AxisPtr) );

